#!/bin/bash

set -e

echo $SSH_KEY | base64 -d >> /tmp/key
chmod -R 0600 /tmp/key

rsync -e "ssh -i /tmp/key -o StrictHostKeyChecking=no" -avz --delete ./systemd/ $RSYNC_DESTINATION/.config/systemd/user/

cd dist
for item in *; do
    echo "copying $item"
	if [ -d "$item" ]; then
        SOURCE_PATH="$item/"
        DEST_PATH="$RSYNC_DESTINATION/$item/"
    else
        SOURCE_PATH="$item"
        DEST_PATH="$RSYNC_DESTINATION"
    fi
    rsync -e "ssh -i /tmp/key -o StrictHostKeyChecking=no" -avz --delete $SOURCE_PATH $DEST_PATH
done
cd ..
echo "finished copying to remote host..."

ssh -i /tmp/key -o StrictHostKeyChecking=no $(echo "${RSYNC_DESTINATION%%:*}") "systemctl daemon-reload --user ; systemctl stop --user fruitvote ; systemctl start --user fruitvote"
echo "reloading fruitvote..."

rm /tmp/key
